# Class JInternalFrame

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JInternalFrame

All Implemented Interfaces:
  `ImageObserver, MenuContainer, Serializable, Accessible, RootPaneContainer, WindowConstants`

@JavaBean(defaultProperty="JMenuBar", description="A frame container which is contained within another window.") public class JInternalFrame extends JComponent implements Accessible, WindowConstants, RootPaneContainer
A lightweight object that provides many of the features of a native frame, including dragging, closing, becoming an icon, resizing, title display, and support for a menu bar. For task-oriented documentation and examples of using internal frames, see How to Use Internal Frames, a section in The Java Tutorial.

Generally, you add `JInternalFrame`s to a `JDesktopPane`. The UI delegates the look-and-feel-specific actions to the `DesktopManager` object maintained by the `JDesktopPane`.

The `JInternalFrame` content pane is where you add child components. As a convenience, the `add`, `remove`, and `setLayout` methods of this class are overridden, so that they delegate calls to the corresponding methods of the `ContentPane`. For example, you can add a child component to an internal frame as follows:

          internalFrame.add(child);

And the child will be added to the contentPane. The content pane is actually managed by an instance of `JRootPane`, which also manages a layout pane, glass pane, and optional menu bar for the internal frame. Please see the `JRootPane` documentation for a complete description of these components. Refer to `RootPaneContainer` for details on adding, removing and setting the `LayoutManager` of a `JInternalFrame`.

Warning: Swing is not thread safe. For more information see Swing's Threading Policy.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

Since:
  1.2
See Also:
  - `InternalFrameEvent`
  - `JDesktopPane`
  - `DesktopManager`
  - `JInternalFrame.JDesktopIcon`
  - `JRootPane`
  - `RootPaneContainer`

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`JInternalFrame.AccessibleJInternalFrame`
This class implements accessibility support for the `JInternalFrame` class.
`static class`
`JInternalFrame.JDesktopIcon`
This component represents an iconified version of a `JInternalFrame`.

### Nested classes/interfaces declared in class JComponent

`JComponent.AccessibleJComponent`
Modifier and Type
Class
Description
`class`
`JComponent.AccessibleJComponent`
Inner class of JComponent used to provide default support for accessibility.

### Nested classes/interfaces declared in class Container

`Container.AccessibleAWTContainer`
Modifier and Type
Class
Description
`protected class`
`Container.AccessibleAWTContainer`
Inner class of Container used to provide default support for accessibility.

### Nested classes/interfaces declared in class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`
Modifier and Type
Class
Description
`protected class`
`Component.AccessibleAWTComponent`
Inner class of Component used to provide default support for accessibility.
`static enum`
`Component.BaselineResizeBehavior`
Enumeration of the common ways the baseline of a component can change as the size changes.
`protected class`
`Component.BltBufferStrategy`
Inner class for blitting offscreen surfaces to a component.
`protected class`
`Component.FlipBufferStrategy`
Inner class for flipping buffers on a component.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`closable`
The frame can be closed.
`static final String`
`CONTENT_PANE_PROPERTY`
Bound property name.
`protected JInternalFrame.JDesktopIcon`
`desktopIcon`
The icon that is displayed when this internal frame is iconified.
`static final String`
`FRAME_ICON_PROPERTY`
Bound property name.
`protected Icon`
`frameIcon`
The icon shown in the top-left corner of this internal frame.
`static final String`
`GLASS_PANE_PROPERTY`
Bound property name.
`protected boolean`
`iconable`
The frame can "iconified" (shrunk down and displayed as an icon-image).
`static final String`
`IS_CLOSED_PROPERTY`
Constrained property name indicating that the internal frame is closed.
`static final String`
`IS_ICON_PROPERTY`
Constrained property name indicating that the internal frame is iconified.
`static final String`
`IS_MAXIMUM_PROPERTY`
Constrained property name indicating that the internal frame is maximized.
`static final String`
`IS_SELECTED_PROPERTY`
Constrained property name indicated that this frame has selected status.
`protected boolean`
`isClosed`
The frame has been closed.
`protected boolean`
`isIcon`
The frame has been iconified.
`protected boolean`
`isMaximum`
The frame has been expanded to its maximum size.
`protected boolean`
`isSelected`
The frame is currently selected.
`static final String`
`LAYERED_PANE_PROPERTY`
Bound property name.
`protected boolean`
`maximizable`
The frame can be expanded to the size of the desktop pane.
`static final String`
`MENU_BAR_PROPERTY`
Bound property name.
`protected boolean`
`resizable`
The frame's size can be changed.
`static final String`
`ROOT_PANE_PROPERTY`
Bound property name.
`protected JRootPane`
`rootPane`
The `JRootPane` instance that manages the content pane and optional menu bar for this internal frame, as well as the glass pane.
`protected boolean`
`rootPaneCheckingEnabled`
If true then calls to `add` and `setLayout` will be forwarded to the `contentPane`.
`protected String`
`title`
The title displayed in this internal frame's title bar.
`static final String`
`TITLE_PROPERTY`
Bound property name.

### Fields declared in class JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`
Modifier and Type
Field
Description
`protected EventListenerList`
`listenerList`
A list of event listeners for this component.
`static final String`
`TOOL_TIP_TEXT_KEY`
The comment to display when the cursor is over the component, also known as a "value tip", "flyover help", or "flyover label".
`protected ComponentUI`
`ui`
The look and feel delegate for this component.
`static final int`
`UNDEFINED_CONDITION`
Constant used by some of the APIs to mean that no condition is defined.
`static final int`
`WHEN_ANCESTOR_OF_FOCUSED_COMPONENT`
Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is an ancestor of the focused component or is itself the focused component.
`static final int`
`WHEN_FOCUSED`
Constant used for `registerKeyboardAction` that means that the command should be invoked when the component has the focus.
`static final int`
`WHEN_IN_FOCUSED_WINDOW`
Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is in the window that has the focus or is itself the focused component.

### Fields declared in class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`
Modifier and Type
Field
Description
`protected AccessibleContext`
`accessibleContext`
The `AccessibleContext` associated with this `Component`.
`static final float`
`BOTTOM_ALIGNMENT`
Ease-of-use constant for `getAlignmentY`.
`static final float`
`CENTER_ALIGNMENT`
Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
`static final float`
`LEFT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`RIGHT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`TOP_ALIGNMENT`
Ease-of-use constant for `getAlignmentY()`.

### Fields declared in interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`
Modifier and Type
Field
Description
`static final int`
`ABORT`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously was aborted before production was complete.
`static final int`
`ALLBITS`
This flag in the infoflags argument to imageUpdate indicates that a static image which was previously drawn is now complete and can be drawn again in its final form.
`static final int`
`ERROR`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously has encountered an error.
`static final int`
`FRAMEBITS`
This flag in the infoflags argument to imageUpdate indicates that another complete frame of a multi-frame image which was previously drawn is now available to be drawn again.
`static final int`
`HEIGHT`
This flag in the infoflags argument to imageUpdate indicates that the height of the base image is now available and can be taken from the height argument to the imageUpdate callback method.
`static final int`
`PROPERTIES`
This flag in the infoflags argument to imageUpdate indicates that the properties of the image are now available.
`static final int`
`SOMEBITS`
This flag in the infoflags argument to imageUpdate indicates that more pixels needed for drawing a scaled variation of the image are available.
`static final int`
`WIDTH`
This flag in the infoflags argument to imageUpdate indicates that the width of the base image is now available and can be taken from the width argument to the imageUpdate callback method.

### Fields declared in interface WindowConstants

`DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`
Modifier and Type
Field
Description
`static final int`
`DISPOSE_ON_CLOSE`
The dispose-window default window close operation.
`static final int`
`DO_NOTHING_ON_CLOSE`
The do-nothing default window close operation.
`static final int`
`EXIT_ON_CLOSE`
The exit application default window close operation.
`static final int`
`HIDE_ON_CLOSE`
The hide-window default window close operation

## Constructor Summary

Constructors
Constructor
Description
`JInternalFrame()`
Creates a non-resizable, non-closable, non-maximizable, non-iconifiable `JInternalFrame` with no title.
`JInternalFrame(String title)`
Creates a non-resizable, non-closable, non-maximizable, non-iconifiable `JInternalFrame` with the specified title.
`JInternalFrame(String title, boolean resizable)`
Creates a non-closable, non-maximizable, non-iconifiable `JInternalFrame` with the specified title and resizability.
`JInternalFrame(String title, boolean resizable, boolean closable)`
Creates a non-maximizable, non-iconifiable `JInternalFrame` with the specified title, resizability, and closability.
`JInternalFrame(String title, boolean resizable, boolean closable, boolean maximizable)`
Creates a non-iconifiable `JInternalFrame` with the specified title, resizability, closability, and maximizability.
`JInternalFrame(String title, boolean resizable, boolean closable, boolean maximizable, boolean iconifiable)`
Creates a `JInternalFrame` with the specified title, resizability, closability, maximizability, and iconifiability.

## Method Summary

Modifier and Type
Method
Description
`protected void`
`addImpl(Component comp, Object constraints, int index)`
Adds the specified child `Component`.
`void`
`addInternalFrameListener(InternalFrameListener l)`
Adds the specified listener to receive internal frame events from this internal frame.
`protected JRootPane`
`createRootPane()`
Called by the constructor to set up the `JRootPane`.
`void`
`dispose()`
Makes this internal frame invisible, unselected, and closed.
`void`
`doDefaultCloseAction()`
Fires an `INTERNAL_FRAME_CLOSING` event and then performs the action specified by the internal frame's default close operation.
`protected void`
`fireInternalFrameEvent(int id)`
Fires an internal frame event.
`AccessibleContext`
`getAccessibleContext()`
Gets the `AccessibleContext` associated with this `JInternalFrame`.
`Container`
`getContentPane()`
Returns the content pane for this internal frame.
`int`
`getDefaultCloseOperation()`
Returns the default operation that occurs when the user initiates a "close" on this internal frame.
`JInternalFrame.JDesktopIcon`
`getDesktopIcon()`
Returns the `JDesktopIcon` used when this `JInternalFrame` is iconified.
`JDesktopPane`
`getDesktopPane()`
Convenience method that searches the ancestor hierarchy for a `JDesktop` instance.
`final Container`
`getFocusCycleRootAncestor()`
Always returns `null` because `JInternalFrame`s must always be roots of a focus traversal cycle.
`Component`
`getFocusOwner()`
If this `JInternalFrame` is active, returns the child that has focus.
`Icon`
`getFrameIcon()`
Returns the image displayed in the title bar of this internal frame (usually in the top-left corner).
`Component`
`getGlassPane()`
Returns the glass pane for this internal frame.
`InternalFrameListener[]`
`getInternalFrameListeners()`
Returns an array of all the `InternalFrameListener`s added to this `JInternalFrame` with `addInternalFrameListener`.
`JMenuBar`
`getJMenuBar()`
Returns the current `JMenuBar` for this `JInternalFrame`, or `null` if no menu bar has been set.
`Cursor`
`getLastCursor()`
Returns the last `Cursor` that was set by the `setCursor` method that is not a resizable `Cursor`.
`int`
`getLayer()`
Convenience method for getting the layer attribute of this component.
`JLayeredPane`
`getLayeredPane()`
Returns the layered pane for this internal frame.
`JMenuBar`
`getMenuBar()`
Deprecated.
As of Swing version 1.0.3, replaced by `getJMenuBar()`.
`Component`
`getMostRecentFocusOwner()`
Returns the child component of this `JInternalFrame` that will receive the focus when this `JInternalFrame` is selected.
`Rectangle`
`getNormalBounds()`
If the `JInternalFrame` is not in maximized state, returns `getBounds()`; otherwise, returns the bounds that the `JInternalFrame` would be restored to.
`JRootPane`
`getRootPane()`
Returns the `rootPane` object for this internal frame.
`String`
`getTitle()`
Returns the title of the `JInternalFrame`.
`InternalFrameUI`
`getUI()`
Returns the look-and-feel object that renders this component.
`String`
`getUIClassID()`
Returns the name of the look-and-feel class that renders this component.
`final String`
`getWarningString()`
Deprecated, for removal: This API element is subject to removal in a future version.
since JDK 24
`void`
`hide()`
`boolean`
`isClosable()`
Returns whether this `JInternalFrame` can be closed by some user action.
`boolean`
`isClosed()`
Returns whether this `JInternalFrame` is currently closed.
`final boolean`
`isFocusCycleRoot()`
Always returns `true` because all `JInternalFrame`s must be roots of a focus traversal cycle.
`boolean`
`isIcon()`
Returns whether the `JInternalFrame` is currently iconified.
`boolean`
`isIconifiable()`
Gets the `iconable` property, which by default is `false`.
`boolean`
`isMaximizable()`
Gets the value of the `maximizable` property.
`boolean`
`isMaximum()`
Returns whether the `JInternalFrame` is currently maximized.
`boolean`
`isResizable()`
Returns whether the `JInternalFrame` can be resized by some user action.
`protected boolean`
`isRootPaneCheckingEnabled()`
Returns whether calls to `add` and `setLayout` are forwarded to the `contentPane`.
`boolean`
`isSelected()`
Returns whether the `JInternalFrame` is the currently "selected" or active frame.
`void`
`moveToBack()`
Convenience method that moves this component to position -1 if its parent is a `JLayeredPane`.
`void`
`moveToFront()`
Convenience method that moves this component to position 0 if its parent is a `JLayeredPane`.
`void`
`pack()`
Causes subcomponents of this `JInternalFrame` to be laid out at their preferred size.
`protected void`
`paintComponent(Graphics g)`
Overridden to allow optimized painting when the internal frame is being dragged.
`protected String`
`paramString()`
Returns a string representation of this `JInternalFrame`.
`void`
`remove(Component comp)`
Removes the specified component from the container.
`void`
`removeInternalFrameListener(InternalFrameListener l)`
Removes the specified internal frame listener so that it no longer receives internal frame events from this internal frame.
`void`
`reshape(int x, int y, int width, int height)`
Moves and resizes this component.
`void`
`restoreSubcomponentFocus()`
Requests the internal frame to restore focus to the last subcomponent that had focus.
`void`
`setClosable(boolean b)`
Sets whether this `JInternalFrame` can be closed by some user action.
`void`
`setClosed(boolean b)`
Closes this internal frame if the argument is `true`.
`void`
`setContentPane(Container c)`
Sets this `JInternalFrame`'s `contentPane` property.
`void`
`setCursor(Cursor cursor)`
Sets the cursor image to the specified cursor.
`void`
`setDefaultCloseOperation(int operation)`
Sets the operation that will happen by default when the user initiates a "close" on this internal frame.
`void`
`setDesktopIcon(JInternalFrame.JDesktopIcon d)`
Sets the `JDesktopIcon` associated with this `JInternalFrame`.
`final void`
`setFocusCycleRoot(boolean focusCycleRoot)`
Does nothing because `JInternalFrame`s must always be roots of a focus traversal cycle.
`void`
`setFrameIcon(Icon icon)`
Sets an image to be displayed in the titlebar of this internal frame (usually in the top-left corner).
`void`
`setGlassPane(Component glass)`
Sets this `JInternalFrame`'s `glassPane` property.
`void`
`setIcon(boolean b)`
Iconifies or de-iconifies this internal frame, if the look and feel supports iconification.
`void`
`setIconifiable(boolean b)`
Sets the `iconable` property, which must be `true` for the user to be able to make the `JInternalFrame` an icon.
`void`
`setJMenuBar(JMenuBar m)`
Sets the `menuBar` property for this `JInternalFrame`.
`void`
`setLayer(int layer)`
Convenience method for setting the layer attribute of this component.
`void`
`setLayer(Integer layer)`
Convenience method for setting the layer attribute of this component.
`void`
`setLayeredPane(JLayeredPane layered)`
Sets this `JInternalFrame`'s `layeredPane` property.
`void`
`setLayout(LayoutManager manager)`
Ensures that, by default, the layout of this component cannot be set.
`void`
`setMaximizable(boolean b)`
Sets the `maximizable` property, which determines whether the `JInternalFrame` can be maximized by some user action.
`void`
`setMaximum(boolean b)`
Maximizes and restores this internal frame.
`void`
`setMenuBar(JMenuBar m)`
Deprecated.
As of Swing version 1.0.3 replaced by `setJMenuBar(JMenuBar m)`.
`void`
`setNormalBounds(Rectangle r)`
Sets the normal bounds for this internal frame, the bounds that this internal frame would be restored to from its maximized state.
`void`
`setResizable(boolean b)`
Sets whether the `JInternalFrame` can be resized by some user action.
`protected void`
`setRootPane(JRootPane root)`
Sets the `rootPane` property for this `JInternalFrame`.
`protected void`
`setRootPaneCheckingEnabled(boolean enabled)`
Sets whether calls to `add` and `setLayout` are forwarded to the `contentPane`.
`void`
`setSelected(boolean selected)`
Selects or deselects the internal frame if it's showing.
`void`
`setTitle(String title)`
Sets the `JInternalFrame` title.
`void`
`setUI(InternalFrameUI ui)`
Sets the UI delegate for this `JInternalFrame`.
`void`
`show()`
If the internal frame is not visible, brings the internal frame to the front, makes it visible, and attempts to select it.
`void`
`toBack()`
Sends this internal frame to the back.
`void`
`toFront()`
Brings this internal frame to the front.
`void`
`updateUI()`
Notification from the `UIManager` that the look and feel has changed.

### Methods declared in class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`
Modifier and Type
Method
Description
`void`
`addAncestorListener(AncestorListener listener)`
Registers `listener` so that it will receive `AncestorEvents` when it or any of its ancestors move or are made visible or invisible.
`void`
`addNotify()`
Notifies this component that it now has a parent component.
`void`
`addVetoableChangeListener(VetoableChangeListener listener)`
Adds a `VetoableChangeListener` to the listener list.
`void`
`computeVisibleRect(Rectangle visibleRect)`
Returns the `Component`'s "visible rect rectangle" - the intersection of the visible rectangles for this component and all of its ancestors.
`boolean`
`contains(int x, int y)`
Gives the UI delegate an opportunity to define the precise shape of this component for the sake of mouse processing.
`JToolTip`
`createToolTip()`
Returns the instance of `JToolTip` that should be used to display the tooltip.
`void`
`disable()`
Deprecated.
As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
`void`
`enable()`
Deprecated.
As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
`void`
`firePropertyChange(String propertyName, boolean oldValue, boolean newValue)`
Support for reporting bound property changes for boolean properties.
`void`
`firePropertyChange(String propertyName, int oldValue, int newValue)`
Support for reporting bound property changes for integer properties.
`protected void`
`fireVetoableChange(String propertyName, Object oldValue, Object newValue)`
Supports reporting constrained property changes.
`ActionListener`
`getActionForKeyStroke(KeyStroke aKeyStroke)`
Returns the object that will perform the action registered for a given keystroke.
`final ActionMap`
`getActionMap()`
Returns the `ActionMap` used to determine what `Action` to fire for particular `KeyStroke` binding.
`float`
`getAlignmentX()`
Overrides `Container.getAlignmentX` to return the horizontal alignment.
`float`
`getAlignmentY()`
Overrides `Container.getAlignmentY` to return the vertical alignment.
`AncestorListener[]`
`getAncestorListeners()`
Returns an array of all the ancestor listeners registered on this component.
`boolean`
`getAutoscrolls()`
Gets the `autoscrolls` property.
`int`
`getBaseline(int width, int height)`
Returns the baseline.
`Component.BaselineResizeBehavior`
`getBaselineResizeBehavior()`
Returns an enum indicating how the baseline of the component changes as the size changes.
`Border`
`getBorder()`
Returns the border of this component or `null` if no border is currently set.
`Rectangle`
`getBounds(Rectangle rv)`
Stores the bounds of this component into "return value" `rv` and returns `rv`.
`final Object`
`getClientProperty(Object key)`
Returns the value of the property with the specified key.
`protected Graphics`
`getComponentGraphics(Graphics g)`
Returns the graphics object used to paint this component.
`JPopupMenu`
`getComponentPopupMenu()`
Returns `JPopupMenu` that assigned for this component.
`int`
`getConditionForKeyStroke(KeyStroke aKeyStroke)`
Returns the condition that determines whether a registered action occurs in response to the specified keystroke.
`int`
`getDebugGraphicsOptions()`
Returns the state of graphics debugging.
`static Locale`
`getDefaultLocale()`
Returns the default locale used to initialize each JComponent's locale property upon creation.
`FontMetrics`
`getFontMetrics(Font font)`
Gets the `FontMetrics` for the specified `Font`.
`Graphics`
`getGraphics()`
Returns this component's graphics context, which lets you draw on a component.
`int`
`getHeight()`
Returns the current height of this component.
`boolean`
`getInheritsPopupMenu()`
Returns true if the JPopupMenu should be inherited from the parent.
`final InputMap`
`getInputMap()`
Returns the `InputMap` that is used when the component has focus.
`final InputMap`
`getInputMap(int condition)`
Returns the `InputMap` that is used during `condition`.
`InputVerifier`
`getInputVerifier()`
Returns the input verifier for this component.
`Insets`
`getInsets()`
If a border has been set on this component, returns the border's insets; otherwise calls `super.getInsets`.
`Insets`
`getInsets(Insets insets)`
Returns an `Insets` object containing this component's inset values.
`<T extends EventListener>
T[]`
`getListeners(Class<T> listenerType)`
Returns an array of all the objects currently registered as `FooListener`s upon this `JComponent`.
`Point`
`getLocation(Point rv)`
Stores the x,y origin of this component into "return value" `rv` and returns `rv`.
`Dimension`
`getMaximumSize()`
If the maximum size has been set to a non-`null` value just returns it.
`Dimension`
`getMinimumSize()`
If the minimum size has been set to a non-`null` value just returns it.
`Component`
`getNextFocusableComponent()`
Deprecated.
As of 1.4, replaced by `FocusTraversalPolicy`.
`Point`
`getPopupLocation(MouseEvent event)`
Returns the preferred location to display the popup menu in this component's coordinate system.
`Dimension`
`getPreferredSize()`
If the `preferredSize` has been set to a non-`null` value just returns it.
`KeyStroke[]`
`getRegisteredKeyStrokes()`
Returns the `KeyStrokes` that will initiate registered actions.
`Dimension`
`getSize(Dimension rv)`
Stores the width/height of this component into "return value" `rv` and returns `rv`.
`Point`
`getToolTipLocation(MouseEvent event)`
Returns the tooltip location in this component's coordinate system.
`String`
`getToolTipText()`
Returns the tooltip string that has been set with `setToolTipText`.
`String`
`getToolTipText(MouseEvent event)`
Returns the string to be used as the tooltip for event.
`Container`
`getTopLevelAncestor()`
Returns the top-level ancestor of this component (the containing `Window`) or `null` if this component has not been added to any container.
`TransferHandler`
`getTransferHandler()`
Gets the `transferHandler` property.
`boolean`
`getVerifyInputWhenFocusTarget()`
Returns the value that indicates whether the input verifier for the current focus owner will be called before this component requests focus.
`VetoableChangeListener[]`
`getVetoableChangeListeners()`
Returns an array of all the vetoable change listeners registered on this component.
`Rectangle`
`getVisibleRect()`
Returns the `Component`'s "visible rectangle" - the intersection of this component's visible rectangle, `new Rectangle(0, 0, getWidth(), getHeight())`, and all of its ancestors' visible rectangles.
`int`
`getWidth()`
Returns the current width of this component.
`int`
`getX()`
Returns the current x coordinate of the component's origin.
`int`
`getY()`
Returns the current y coordinate of the component's origin.
`void`
`grabFocus()`
Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`boolean`
`isDoubleBuffered()`
Returns whether this component should use a buffer to paint.
`static boolean`
`isLightweightComponent(Component c)`
Returns true if this component is lightweight, that is, if it doesn't have a native window system peer.
`boolean`
`isManagingFocus()`
Deprecated.
As of 1.4, replaced by `Component.setFocusTraversalKeys(int, Set)` and `Container.setFocusCycleRoot(boolean)`.
`boolean`
`isOpaque()`
Returns true if this component is completely opaque.
`boolean`
`isOptimizedDrawingEnabled()`
Returns true if this component tiles its children -- that is, if it can guarantee that the children will not overlap.
`final boolean`
`isPaintingForPrint()`
Returns `true` if the current painting operation on this component is part of a `print` operation.
`protected boolean`
`isPaintingOrigin()`
Returns `true` if a paint triggered on a child component should cause painting to originate from this Component, or one of its ancestors.
`boolean`
`isPaintingTile()`
Returns true if the component is currently painting a tile.
`boolean`
`isRequestFocusEnabled()`
Returns `true` if this `JComponent` should get focus; otherwise returns `false`.
`boolean`
`isValidateRoot()`
If this method returns true, `revalidate` calls by descendants of this component will cause the entire tree beginning with this root to be validated.
`void`
`paint(Graphics g)`
Invoked by Swing to draw components.
`protected void`
`paintBorder(Graphics g)`
Paints the component's border.
`protected void`
`paintChildren(Graphics g)`
Paints this component's children.
`void`
`paintImmediately(int x, int y, int w, int h)`
Paints the specified region in this component and all of its descendants that overlap the region, immediately.
`void`
`paintImmediately(Rectangle r)`
Paints the specified region now.
`void`
`print(Graphics g)`
Invoke this method to print the component to the specified `Graphics`.
`void`
`printAll(Graphics g)`
Invoke this method to print the component.
`protected void`
`printBorder(Graphics g)`
Prints the component's border.
`protected void`
`printChildren(Graphics g)`
Prints this component's children.
`protected void`
`printComponent(Graphics g)`
This is invoked during a printing operation.
`protected void`
`processComponentKeyEvent(KeyEvent e)`
Processes any key events that the component itself recognizes.
`protected boolean`
`processKeyBinding(KeyStroke ks, KeyEvent e, int condition, boolean pressed)`
Invoked to process the key bindings for `ks` as the result of the `KeyEvent` `e`.
`protected void`
`processKeyEvent(KeyEvent e)`
Overrides `processKeyEvent` to process events.
`protected void`
`processMouseEvent(MouseEvent e)`
Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects, refer to `Component.processMouseEvent(MouseEvent)` for a complete description of this method.
`protected void`
`processMouseMotionEvent(MouseEvent e)`
Processes mouse motion events, such as MouseEvent.MOUSE_DRAGGED.
`final void`
`putClientProperty(Object key, Object value)`
Adds an arbitrary key/value "client property" to this component.
`void`
`registerKeyboardAction(ActionListener anAction, String aCommand, KeyStroke aKeyStroke, int aCondition)`
This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
`void`
`registerKeyboardAction(ActionListener anAction, KeyStroke aKeyStroke, int aCondition)`
This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
`void`
`removeAncestorListener(AncestorListener listener)`
Unregisters `listener` so that it will no longer receive `AncestorEvents`.
`void`
`removeNotify()`
Notifies this component that it no longer has a parent component.
`void`
`removeVetoableChangeListener(VetoableChangeListener listener)`
Removes a `VetoableChangeListener` from the listener list.
`void`
`repaint(long tm, int x, int y, int width, int height)`
Adds the specified region to the dirty region list if the component is showing.
`void`
`repaint(Rectangle r)`
Adds the specified region to the dirty region list if the component is showing.
`boolean`
`requestDefaultFocus()`
Deprecated.
As of 1.4, replaced by `FocusTraversalPolicy.getDefaultComponent(Container).requestFocus()`
`void`
`requestFocus()`
Requests that this `Component` gets the input focus.
`boolean`
`requestFocus(boolean temporary)`
Requests that this `Component` gets the input focus.
`boolean`
`requestFocusInWindow()`
Requests that this `Component` gets the input focus.
`protected boolean`
`requestFocusInWindow(boolean temporary)`
Requests that this `Component` gets the input focus.
`void`
`resetKeyboardActions()`
Unregisters all the bindings in the first tier `InputMaps` and `ActionMap`.
`void`
`revalidate()`
Supports deferred automatic layout.
`void`
`scrollRectToVisible(Rectangle aRect)`
Forwards the `scrollRectToVisible()` message to the `JComponent`'s parent.
`final void`
`setActionMap(ActionMap am)`
Sets the `ActionMap` to `am`.
`void`
`setAlignmentX(float alignmentX)`
Sets the horizontal alignment.
`void`
`setAlignmentY(float alignmentY)`
Sets the vertical alignment.
`void`
`setAutoscrolls(boolean autoscrolls)`
Sets the `autoscrolls` property.
`void`
`setBackground(Color bg)`
Sets the background color of this component.
`void`
`setBorder(Border border)`
Sets the border of this component.
`void`
`setComponentPopupMenu(JPopupMenu popup)`
Sets the `JPopupMenu` for this `JComponent`.
`void`
`setDebugGraphicsOptions(int debugOptions)`
Enables or disables diagnostic information about every graphics operation performed within the component or one of its children.
`static void`
`setDefaultLocale(Locale l)`
Sets the default locale used to initialize each JComponent's locale property upon creation.
`void`
`setDoubleBuffered(boolean aFlag)`
Sets whether this component should use a buffer to paint.
`void`
`setEnabled(boolean enabled)`
Sets whether or not this component is enabled.
`void`
`setFocusTraversalKeys(int id, Set<? extends AWTKeyStroke> keystrokes)`
Sets the focus traversal keys for a given traversal operation for this Component.
`void`
`setFont(Font font)`
Sets the font for this component.
`void`
`setForeground(Color fg)`
Sets the foreground color of this component.
`void`
`setInheritsPopupMenu(boolean value)`
Sets whether or not `getComponentPopupMenu` should delegate to the parent if this component does not have a `JPopupMenu` assigned to it.
`final void`
`setInputMap(int condition, InputMap map)`
Sets the `InputMap` to use under the condition `condition` to `map`.
`void`
`setInputVerifier(InputVerifier inputVerifier)`
Sets the input verifier for this component.
`void`
`setMaximumSize(Dimension maximumSize)`
Sets the maximum size of this component to a constant value.
`void`
`setMinimumSize(Dimension minimumSize)`
Sets the minimum size of this component to a constant value.
`void`
`setNextFocusableComponent(Component aComponent)`
Deprecated.
As of 1.4, replaced by `FocusTraversalPolicy`
`void`
`setOpaque(boolean isOpaque)`
If true the component paints every pixel within its bounds.
`void`
`setPreferredSize(Dimension preferredSize)`
Sets the preferred size of this component.
`void`
`setRequestFocusEnabled(boolean requestFocusEnabled)`
Provides a hint as to whether or not this `JComponent` should get focus.
`void`
`setToolTipText(String text)`
Registers the text to display in a tool tip.
`void`
`setTransferHandler(TransferHandler newHandler)`
Sets the `TransferHandler`, which provides support for transfer of data into and out of this component via cut/copy/paste and drag and drop.
`protected void`
`setUI(ComponentUI newUI)`
Sets the look and feel delegate for this component.
`void`
`setVerifyInputWhenFocusTarget(boolean verifyInputWhenFocusTarget)`
Sets the value to indicate whether input verifier for the current focus owner will be called before this component requests focus.
`void`
`setVisible(boolean aFlag)`
Makes the component visible or invisible.
`void`
`unregisterKeyboardAction(KeyStroke aKeyStroke)`
This method is now obsolete.
`void`
`update(Graphics g)`
Calls `paint`.

### Methods declared in class Container

`add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, transferFocusDownCycle, validate, validateTree`
Modifier and Type
Method
Description
`Component`
`add(Component comp)`
Appends the specified component to the end of this container.
`Component`
`add(Component comp, int index)`
Adds the specified component to this container at the given position.
`void`
`add(Component comp, Object constraints)`
Adds the specified component to the end of this container.
`void`
`add(Component comp, Object constraints, int index)`
Adds the specified component to this container with the specified constraints at the specified index.
`Component`
`add(String name, Component comp)`
Adds the specified component to this container.
`void`
`addContainerListener(ContainerListener l)`
Adds the specified container listener to receive container events from this container.
`void`
`addPropertyChangeListener(PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list.
`void`
`addPropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list for a specific property.
`void`
`applyComponentOrientation(ComponentOrientation o)`
Sets the `ComponentOrientation` property of this container and all components contained within it.
`boolean`
`areFocusTraversalKeysSet(int id)`
Returns whether the Set of focus traversal keys for the given focus traversal operation has been explicitly defined for this Container.
`int`
`countComponents()`
Deprecated.
As of JDK version 1.1, replaced by getComponentCount().
`void`
`deliverEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`
`void`
`doLayout()`
Causes this container to lay out its components.
`Component`
`findComponentAt(int x, int y)`
Locates the visible child component that contains the specified position.
`Component`
`findComponentAt(Point p)`
Locates the visible child component that contains the specified point.
`Component`
`getComponent(int n)`
Gets the nth component in this container.
`Component`
`getComponentAt(int x, int y)`
Locates the component that contains the x,y position.
`Component`
`getComponentAt(Point p)`
Gets the component that contains the specified point.
`int`
`getComponentCount()`
Gets the number of components in this panel.
`Component[]`
`getComponents()`
Gets all the components in this container.
`int`
`getComponentZOrder(Component comp)`
Returns the z-order index of the component inside the container.
`ContainerListener[]`
`getContainerListeners()`
Returns an array of all the container listeners registered on this container.
`Set<AWTKeyStroke>`
`getFocusTraversalKeys(int id)`
Returns the Set of focus traversal keys for a given traversal operation for this Container.
`FocusTraversalPolicy`
`getFocusTraversalPolicy()`
Returns the focus traversal policy that will manage keyboard traversal of this Container's children, or null if this Container is not a focus cycle root.
`LayoutManager`
`getLayout()`
Gets the layout manager for this container.
`Point`
`getMousePosition(boolean allowChildren)`
Returns the position of the mouse pointer in this `Container`'s coordinate space if the `Container` is under the mouse pointer, otherwise returns `null`.
`Insets`
`insets()`
Deprecated.
As of JDK version 1.1, replaced by `getInsets()`.
`void`
`invalidate()`
Invalidates the container.
`boolean`
`isAncestorOf(Component c)`
Checks if the component is contained in the component hierarchy of this container.
`boolean`
`isFocusCycleRoot(Container container)`
Returns whether the specified Container is the focus cycle root of this Container's focus traversal cycle.
`final boolean`
`isFocusTraversalPolicyProvider()`
Returns whether this container provides focus traversal policy.
`boolean`
`isFocusTraversalPolicySet()`
Returns whether the focus traversal policy has been explicitly set for this Container.
`void`
`layout()`
Deprecated.
As of JDK version 1.1, replaced by `doLayout()`.
`void`
`list(PrintStream out, int indent)`
Prints a listing of this container to the specified output stream.
`void`
`list(PrintWriter out, int indent)`
Prints out a list, starting at the specified indentation, to the specified print writer.
`Component`
`locate(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by `getComponentAt(int, int)`.
`Dimension`
`minimumSize()`
Deprecated.
As of JDK version 1.1, replaced by `getMinimumSize()`.
`void`
`paintComponents(Graphics g)`
Paints each of the components in this container.
`Dimension`
`preferredSize()`
Deprecated.
As of JDK version 1.1, replaced by `getPreferredSize()`.
`void`
`printComponents(Graphics g)`
Prints each of the components in this container.
`protected void`
`processContainerEvent(ContainerEvent e)`
Processes container events occurring on this container by dispatching them to any registered ContainerListener objects.
`protected void`
`processEvent(AWTEvent e)`
Processes events on this container.
`void`
`remove(int index)`
Removes the component, specified by `index`, from this container.
`void`
`removeAll()`
Removes all the components from this container.
`void`
`removeContainerListener(ContainerListener l)`
Removes the specified container listener so it no longer receives container events from this container.
`void`
`setComponentZOrder(Component comp, int index)`
Moves the specified component to the specified z-order index in the container.
`void`
`setFocusTraversalPolicy(FocusTraversalPolicy policy)`
Sets the focus traversal policy that will manage keyboard traversal of this Container's children, if this Container is a focus cycle root.
`final void`
`setFocusTraversalPolicyProvider(boolean provider)`
Sets whether this container will be used to provide focus traversal policy.
`void`
`transferFocusDownCycle()`
Transfers the focus down one focus traversal cycle.
`void`
`validate()`
Validates this container and all of its subcomponents.
`protected void`
`validateTree()`
Recursively descends the container tree and recomputes the layout for any subtrees marked as needing it (those marked as invalid).

### Methods declared in class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`
Modifier and Type
Method
Description
`boolean`
`action(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
`void`
`add(PopupMenu popup)`
Adds the specified popup menu to the component.
`void`
`addComponentListener(ComponentListener l)`
Adds the specified component listener to receive component events from this component.
`void`
`addFocusListener(FocusListener l)`
Adds the specified focus listener to receive focus events from this component when this component gains input focus.
`void`
`addHierarchyBoundsListener(HierarchyBoundsListener l)`
Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
`void`
`addHierarchyListener(HierarchyListener l)`
Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
`void`
`addInputMethodListener(InputMethodListener l)`
Adds the specified input method listener to receive input method events from this component.
`void`
`addKeyListener(KeyListener l)`
Adds the specified key listener to receive key events from this component.
`void`
`addMouseListener(MouseListener l)`
Adds the specified mouse listener to receive mouse events from this component.
`void`
`addMouseMotionListener(MouseMotionListener l)`
Adds the specified mouse motion listener to receive mouse motion events from this component.
`void`
`addMouseWheelListener(MouseWheelListener l)`
Adds the specified mouse wheel listener to receive mouse wheel events from this component.
`Rectangle`
`bounds()`
Deprecated.
As of JDK version 1.1, replaced by `getBounds()`.
`int`
`checkImage(Image image, int width, int height, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`int`
`checkImage(Image image, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`protected AWTEvent`
`coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)`
Potentially coalesce an event being posted with an existing event.
`boolean`
`contains(Point p)`
Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
`Image`
`createImage(int width, int height)`
Creates an off-screen drawable image to be used for double buffering.
`Image`
`createImage(ImageProducer producer)`
Creates an image from the specified image producer.
`VolatileImage`
`createVolatileImage(int width, int height)`
Creates a volatile off-screen drawable image to be used for double buffering.
`VolatileImage`
`createVolatileImage(int width, int height, ImageCapabilities caps)`
Creates a volatile off-screen drawable image, with the given capabilities.
`protected final void`
`disableEvents(long eventsToDisable)`
Disables the events defined by the specified event mask parameter from being delivered to this component.
`final void`
`dispatchEvent(AWTEvent e)`
Dispatches an event to this component or one of its sub components.
`void`
`enable(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`protected final void`
`enableEvents(long eventsToEnable)`
Enables the events defined by the specified event mask parameter to be delivered to this component.
`void`
`enableInputMethods(boolean enable)`
Enables or disables input method support for this component.
`void`
`firePropertyChange(String propertyName, byte oldValue, byte newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, char oldValue, char newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, double oldValue, double newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, float oldValue, float newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, long oldValue, long newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, short oldValue, short newValue)`
Reports a bound property change.
`protected void`
`firePropertyChange(String propertyName, Object oldValue, Object newValue)`
Support for reporting bound property changes for Object properties.
`Color`
`getBackground()`
Gets the background color of this component.
`Rectangle`
`getBounds()`
Gets the bounds of this component in the form of a `Rectangle` object.
`ColorModel`
`getColorModel()`
Gets the instance of `ColorModel` used to display the component on the output device.
`ComponentListener[]`
`getComponentListeners()`
Returns an array of all the component listeners registered on this component.
`ComponentOrientation`
`getComponentOrientation()`
Retrieves the language-sensitive orientation that is to be used to order the elements or text within this component.
`Cursor`
`getCursor()`
Gets the cursor set in the component.
`DropTarget`
`getDropTarget()`
Gets the `DropTarget` associated with this `Component`.
`FocusListener[]`
`getFocusListeners()`
Returns an array of all the focus listeners registered on this component.
`boolean`
`getFocusTraversalKeysEnabled()`
Returns whether focus traversal keys are enabled for this Component.
`Font`
`getFont()`
Gets the font of this component.
`Color`
`getForeground()`
Gets the foreground color of this component.
`GraphicsConfiguration`
`getGraphicsConfiguration()`
Gets the `GraphicsConfiguration` associated with this `Component`.
`HierarchyBoundsListener[]`
`getHierarchyBoundsListeners()`
Returns an array of all the hierarchy bounds listeners registered on this component.
`HierarchyListener[]`
`getHierarchyListeners()`
Returns an array of all the hierarchy listeners registered on this component.
`boolean`
`getIgnoreRepaint()`
Returns whether or not paint messages received from the operating system should be ignored.
`InputContext`
`getInputContext()`
Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
`InputMethodListener[]`
`getInputMethodListeners()`
Returns an array of all the input method listeners registered on this component.
`InputMethodRequests`
`getInputMethodRequests()`
Gets the input method request handler which supports requests from input methods for this component.
`KeyListener[]`
`getKeyListeners()`
Returns an array of all the key listeners registered on this component.
`Locale`
`getLocale()`
Gets the locale of this component.
`Point`
`getLocation()`
Gets the location of this component in the form of a point specifying the component's top-left corner.
`Point`
`getLocationOnScreen()`
Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
`MouseListener[]`
`getMouseListeners()`
Returns an array of all the mouse listeners registered on this component.
`MouseMotionListener[]`
`getMouseMotionListeners()`
Returns an array of all the mouse motion listeners registered on this component.
`Point`
`getMousePosition()`
Returns the position of the mouse pointer in this `Component`'s coordinate space if the `Component` is directly under the mouse pointer, otherwise returns `null`.
`MouseWheelListener[]`
`getMouseWheelListeners()`
Returns an array of all the mouse wheel listeners registered on this component.
`String`
`getName()`
Gets the name of the component.
`Container`
`getParent()`
Gets the parent of this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners()`
Returns an array of all the property change listeners registered on this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners(String propertyName)`
Returns an array of all the listeners which have been associated with the named property.
`Dimension`
`getSize()`
Returns the size of this component in the form of a `Dimension` object.
`Toolkit`
`getToolkit()`
Gets the toolkit of this component.
`final Object`
`getTreeLock()`
Gets this component's locking object (the object that owns the thread synchronization monitor) for AWT component-tree and layout operations.
`boolean`
`gotFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean`
`handleEvent(Event evt)`
Deprecated.
As of JDK version 1.1 replaced by processEvent(AWTEvent).
`boolean`
`hasFocus()`
Returns `true` if this `Component` is the focus owner.
`boolean`
`imageUpdate(Image img, int infoflags, int x, int y, int w, int h)`
Repaints the component when the image has changed.
`boolean`
`inside(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by contains(int, int).
`boolean`
`isBackgroundSet()`
Returns whether the background color has been explicitly set for this Component.
`boolean`
`isCursorSet()`
Returns whether the cursor has been explicitly set for this Component.
`boolean`
`isDisplayable()`
Determines whether this component is displayable.
`boolean`
`isEnabled()`
Determines whether this component is enabled.
`boolean`
`isFocusable()`
Returns whether this Component can be focused.
`boolean`
`isFocusOwner()`
Returns `true` if this `Component` is the focus owner.
`boolean`
`isFocusTraversable()`
Deprecated.
As of 1.4, replaced by `isFocusable()`.
`boolean`
`isFontSet()`
Returns whether the font has been explicitly set for this Component.
`boolean`
`isForegroundSet()`
Returns whether the foreground color has been explicitly set for this Component.
`boolean`
`isLightweight()`
A lightweight component doesn't have a native toolkit peer.
`boolean`
`isMaximumSizeSet()`
Returns true if the maximum size has been set to a non-`null` value otherwise returns false.
`boolean`
`isMinimumSizeSet()`
Returns whether or not `setMinimumSize` has been invoked with a non-null value.
`boolean`
`isPreferredSizeSet()`
Returns true if the preferred size has been set to a non-`null` value otherwise returns false.
`boolean`
`isShowing()`
Determines whether this component is showing on screen.
`boolean`
`isValid()`
Determines whether this component is valid.
`boolean`
`isVisible()`
Determines whether this component should be visible when its parent is visible.
`boolean`
`keyDown(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`boolean`
`keyUp(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`void`
`list()`
Prints a listing of this component to the standard system output stream `System.out`.
`void`
`list(PrintStream out)`
Prints a listing of this component to the specified output stream.
`void`
`list(PrintWriter out)`
Prints a listing to the specified print writer.
`Point`
`location()`
Deprecated.
As of JDK version 1.1, replaced by `getLocation()`.
`boolean`
`lostFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean`
`mouseDown(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseDrag(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseEnter(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseExit(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseMove(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseUp(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`void`
`move(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by `setLocation(int, int)`.
`void`
`nextFocus()`
Deprecated.
As of JDK version 1.1, replaced by transferFocus().
`void`
`paintAll(Graphics g)`
Paints this component and all of its subcomponents.
`boolean`
`postEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
`boolean`
`prepareImage(Image image, int width, int height, ImageObserver observer)`
Prepares an image for rendering on this component at the specified width and height.
`boolean`
`prepareImage(Image image, ImageObserver observer)`
Prepares an image for rendering on this component.
`protected void`
`processComponentEvent(ComponentEvent e)`
Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
`protected void`
`processFocusEvent(FocusEvent e)`
Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
`protected void`
`processHierarchyBoundsEvent(HierarchyEvent e)`
Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
`protected void`
`processHierarchyEvent(HierarchyEvent e)`
Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
`protected void`
`processInputMethodEvent(InputMethodEvent e)`
Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
`protected void`
`processMouseWheelEvent(MouseWheelEvent e)`
Processes mouse wheel events occurring on this component by dispatching them to any registered `MouseWheelListener` objects.
`void`
`remove(MenuComponent popup)`
Removes the specified popup menu from the component.
`void`
`removeComponentListener(ComponentListener l)`
Removes the specified component listener so that it no longer receives component events from this component.
`void`
`removeFocusListener(FocusListener l)`
Removes the specified focus listener so that it no longer receives focus events from this component.
`void`
`removeHierarchyBoundsListener(HierarchyBoundsListener l)`
Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
`void`
`removeHierarchyListener(HierarchyListener l)`
Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
`void`
`removeInputMethodListener(InputMethodListener l)`
Removes the specified input method listener so that it no longer receives input method events from this component.
`void`
`removeKeyListener(KeyListener l)`
Removes the specified key listener so that it no longer receives key events from this component.
`void`
`removeMouseListener(MouseListener l)`
Removes the specified mouse listener so that it no longer receives mouse events from this component.
`void`
`removeMouseMotionListener(MouseMotionListener l)`
Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
`void`
`removeMouseWheelListener(MouseWheelListener l)`
Removes the specified mouse wheel listener so that it no longer receives mouse wheel events from this component.
`void`
`removePropertyChangeListener(PropertyChangeListener listener)`
Removes a PropertyChangeListener from the listener list.
`void`
`removePropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Removes a `PropertyChangeListener` from the listener list for a specific property.
`void`
`repaint()`
Repaints this component.
`void`
`repaint(int x, int y, int width, int height)`
Repaints the specified rectangle of this component.
`void`
`repaint(long tm)`
Repaints the component.
`protected boolean`
`requestFocus(boolean temporary, FocusEvent.Cause cause)`
Requests by the reason of `cause` that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
`void`
`requestFocus(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`boolean`
`requestFocusInWindow(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
`void`
`resize(int width, int height)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(int, int)`.
`void`
`resize(Dimension d)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(Dimension)`.
`void`
`setBounds(int x, int y, int width, int height)`
Moves and resizes this component.
`void`
`setBounds(Rectangle r)`
Moves and resizes this component to conform to the new bounding rectangle `r`.
`void`
`setComponentOrientation(ComponentOrientation o)`
Sets the language-sensitive orientation that is to be used to order the elements or text within this component.
`void`
`setDropTarget(DropTarget dt)`
Associate a `DropTarget` with this component.
`void`
`setFocusable(boolean focusable)`
Sets the focusable state of this Component to the specified value.
`void`
`setFocusTraversalKeysEnabled(boolean focusTraversalKeysEnabled)`
Sets whether focus traversal keys are enabled for this Component.
`void`
`setIgnoreRepaint(boolean ignoreRepaint)`
Sets whether or not paint messages received from the operating system should be ignored.
`void`
`setLocale(Locale l)`
Sets the locale of this component.
`void`
`setLocation(int x, int y)`
Moves this component to a new location.
`void`
`setLocation(Point p)`
Moves this component to a new location.
`void`
`setMixingCutoutShape(Shape shape)`
Sets a 'mixing-cutout' shape for this lightweight component.
`void`
`setName(String name)`
Sets the name of the component to the specified string.
`void`
`setSize(int width, int height)`
Resizes this component so that it has width `width` and height `height`.
`void`
`setSize(Dimension d)`
Resizes this component so that it has width `d.width` and height `d.height`.
`void`
`show(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`Dimension`
`size()`
Deprecated.
As of JDK version 1.1, replaced by `getSize()`.
`String`
`toString()`
Returns a string representation of this component and its values.
`void`
`transferFocus()`
Transfers the focus to the next component, as though this Component were the focus owner.
`void`
`transferFocusBackward()`
Transfers the focus to the previous component, as though this Component were the focus owner.
`void`
`transferFocusUpCycle()`
Transfers the focus up one focus traversal cycle.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### rootPane

protected JRootPane rootPane
The `JRootPane` instance that manages the content pane and optional menu bar for this internal frame, as well as the glass pane.

See Also:
  - `JRootPane`
  - `RootPaneContainer`

### rootPaneCheckingEnabled

protected boolean rootPaneCheckingEnabled
If true then calls to `add` and `setLayout` will be forwarded to the `contentPane`. This is initially false, but is set to true when the `JInternalFrame` is constructed.

See Also:
  - `isRootPaneCheckingEnabled()`
  - `setRootPaneCheckingEnabled(boolean)`
  - `RootPaneContainer`

### closable

protected boolean closable
The frame can be closed.

### isClosed

protected boolean isClosed
The frame has been closed.

### maximizable

protected boolean maximizable
The frame can be expanded to the size of the desktop pane.

### isMaximum

protected boolean isMaximum
The frame has been expanded to its maximum size.

See Also:
  - `maximizable`

### iconable

protected boolean iconable
The frame can "iconified" (shrunk down and displayed as an icon-image).

See Also:
  - `JInternalFrame.JDesktopIcon`
  - `setIconifiable(boolean)`

### isIcon

protected boolean isIcon
The frame has been iconified.

See Also:
  - `isIcon()`

### resizable

protected boolean resizable
The frame's size can be changed.

### isSelected

protected boolean isSelected
The frame is currently selected.

### frameIcon

protected Icon frameIcon
The icon shown in the top-left corner of this internal frame.

### title

protected String title
The title displayed in this internal frame's title bar.

### desktopIcon

protected JInternalFrame.JDesktopIcon desktopIcon
The icon that is displayed when this internal frame is iconified. Subclassers must ensure this is set to a non-null value during construction and not subsequently set this to null.

See Also:
  - `iconable`

### CONTENT_PANE_PROPERTY

public static final String CONTENT_PANE_PROPERTY
Bound property name.

See Also:
  - Constant Field Values

### MENU_BAR_PROPERTY

public static final String MENU_BAR_PROPERTY
Bound property name.

See Also:
  - Constant Field Values

### TITLE_PROPERTY

public static final String TITLE_PROPERTY
Bound property name.

See Also:
  - Constant Field Values

### LAYERED_PANE_PROPERTY

public static final String LAYERED_PANE_PROPERTY
Bound property name.

See Also:
  - Constant Field Values

### ROOT_PANE_PROPERTY

public static final String ROOT_PANE_PROPERTY
Bound property name.

See Also:
  - Constant Field Values

### GLASS_PANE_PROPERTY

public static final String GLASS_PANE_PROPERTY
Bound property name.

See Also:
  - Constant Field Values

### FRAME_ICON_PROPERTY

public static final String FRAME_ICON_PROPERTY
Bound property name.

See Also:
  - Constant Field Values

### IS_SELECTED_PROPERTY

public static final String IS_SELECTED_PROPERTY
Constrained property name indicated that this frame has selected status.

See Also:
  - Constant Field Values

### IS_CLOSED_PROPERTY

public static final String IS_CLOSED_PROPERTY
Constrained property name indicating that the internal frame is closed.

See Also:
  - Constant Field Values

### IS_MAXIMUM_PROPERTY

public static final String IS_MAXIMUM_PROPERTY
Constrained property name indicating that the internal frame is maximized.

See Also:
  - Constant Field Values

### IS_ICON_PROPERTY

public static final String IS_ICON_PROPERTY
Constrained property name indicating that the internal frame is iconified.

See Also:
  - Constant Field Values

## Constructor Details

### JInternalFrame

public JInternalFrame()
Creates a non-resizable, non-closable, non-maximizable, non-iconifiable `JInternalFrame` with no title.

### JInternalFrame

public JInternalFrame(String title)
Creates a non-resizable, non-closable, non-maximizable, non-iconifiable `JInternalFrame` with the specified title. Note that passing in a `null` `title` results in unspecified behavior and possibly an exception.

Parameters:
  `title` - the non-`null` `String` to display in the title bar

### JInternalFrame

public JInternalFrame(String title, boolean resizable)
Creates a non-closable, non-maximizable, non-iconifiable `JInternalFrame` with the specified title and resizability.

Parameters:
  `title` - the `String` to display in the title bar
  `resizable` - if `true`, the internal frame can be resized

### JInternalFrame

public JInternalFrame(String title, boolean resizable, boolean closable)
Creates a non-maximizable, non-iconifiable `JInternalFrame` with the specified title, resizability, and closability.

Parameters:
  `title` - the `String` to display in the title bar
  `resizable` - if `true`, the internal frame can be resized
  `closable` - if `true`, the internal frame can be closed

### JInternalFrame

public JInternalFrame(String title, boolean resizable, boolean closable, boolean maximizable)
Creates a non-iconifiable `JInternalFrame` with the specified title, resizability, closability, and maximizability.

Parameters:
  `title` - the `String` to display in the title bar
  `resizable` - if `true`, the internal frame can be resized
  `closable` - if `true`, the internal frame can be closed
  `maximizable` - if `true`, the internal frame can be maximized

### JInternalFrame

public JInternalFrame(String title, boolean resizable, boolean closable, boolean maximizable, boolean iconifiable)
Creates a `JInternalFrame` with the specified title, resizability, closability, maximizability, and iconifiability. All `JInternalFrame` constructors use this one.

Parameters:
  `title` - the `String` to display in the title bar
  `resizable` - if `true`, the internal frame can be resized
  `closable` - if `true`, the internal frame can be closed
  `maximizable` - if `true`, the internal frame can be maximized
  `iconifiable` - if `true`, the internal frame can be iconified

## Method Details

### createRootPane

protected JRootPane createRootPane()
Called by the constructor to set up the `JRootPane`.

Returns:
  a new `JRootPane`
See Also:
  - `JRootPane`

### getUI

public InternalFrameUI getUI()
Returns the look-and-feel object that renders this component.

Overrides:
  `getUI` in class `JComponent`
Returns:
  the `InternalFrameUI` object that renders this component

### setUI

@BeanProperty(hidden=true, visualUpdate=true, description="The UI object that implements the Component's LookAndFeel.") public void setUI(InternalFrameUI ui)
Sets the UI delegate for this `JInternalFrame`.

Parameters:
  `ui` - the UI delegate

### updateUI

public void updateUI()
Notification from the `UIManager` that the look and feel has changed. Replaces the current UI object with the latest version from the `UIManager`.

Overrides:
  `updateUI` in class `JComponent`
See Also:
  - `JComponent.updateUI()`

### getUIClassID

@BeanProperty(bound=false, description="UIClassID") public String getUIClassID()
Returns the name of the look-and-feel class that renders this component.

Overrides:
  `getUIClassID` in class `JComponent`
Returns:
  the string "InternalFrameUI"
See Also:
  - `JComponent.getUIClassID()`
  - `UIDefaults.getUI(JComponent)`

### isRootPaneCheckingEnabled

protected boolean isRootPaneCheckingEnabled()
Returns whether calls to `add` and `setLayout` are forwarded to the `contentPane`.

Returns:
  true if `add` and `setLayout` are forwarded; false otherwise
See Also:
  - `addImpl(Component, Object, int)`
  - `setLayout(LayoutManager)`
  - `setRootPaneCheckingEnabled(boolean)`
  - `RootPaneContainer`

### setRootPaneCheckingEnabled

@BeanProperty(hidden=true, description="Whether the add and setLayout methods are forwarded") protected void setRootPaneCheckingEnabled(boolean enabled)
Sets whether calls to `add` and `setLayout` are forwarded to the `contentPane`.

Parameters:
  `enabled` - true if `add` and `setLayout` are forwarded, false if they should operate directly on the `JInternalFrame`.
See Also:
  - `addImpl(Component, Object, int)`
  - `setLayout(LayoutManager)`
  - `isRootPaneCheckingEnabled()`
  - `RootPaneContainer`

### addImpl

protected void addImpl(Component comp, Object constraints, int index)
Adds the specified child `Component`. This method is overridden to conditionally forward calls to the `contentPane`. By default, children are added to the `contentPane` instead of the frame, refer to `RootPaneContainer` for details.

Overrides:
  `addImpl` in class `Container`
Parameters:
  `comp` - the component to be enhanced
  `constraints` - the constraints to be respected
  `index` - the index
Throws:
  `IllegalArgumentException` - if `index` is invalid
  `IllegalArgumentException` - if adding the container's parent to itself
  `IllegalArgumentException` - if adding a window to a container
See Also:
  - `setRootPaneCheckingEnabled(boolean)`
  - `RootPaneContainer`

### remove

public void remove(Component comp)
Removes the specified component from the container. If `comp` is not a child of the `JInternalFrame` this will forward the call to the `contentPane`.

Overrides:
  `remove` in class `Container`
Parameters:
  `comp` - the component to be removed
Throws:
  `NullPointerException` - if `comp` is null
See Also:
  - `Container.add(Component)`
  - `RootPaneContainer`

### setLayout

public void setLayout(LayoutManager manager)
Ensures that, by default, the layout of this component cannot be set. Overridden to conditionally forward the call to the `contentPane`. Refer to `RootPaneContainer` for more information.

Overrides:
  `setLayout` in class `Container`
Parameters:
  `manager` - the `LayoutManager`
See Also:
  - `setRootPaneCheckingEnabled(boolean)`

### getMenuBar

@Deprecated public JMenuBar getMenuBar()
Deprecated.
As of Swing version 1.0.3, replaced by `getJMenuBar()`.
Returns the current `JMenuBar` for this `JInternalFrame`, or `null` if no menu bar has been set.

Returns:
  the current menu bar, or `null` if none has been set

### getJMenuBar

public JMenuBar getJMenuBar()
Returns the current `JMenuBar` for this `JInternalFrame`, or `null` if no menu bar has been set.

Returns:
  the `JMenuBar` used by this internal frame
See Also:
  - `setJMenuBar(JMenuBar)`

### setMenuBar

@Deprecated public void setMenuBar(JMenuBar m)
Deprecated.
As of Swing version 1.0.3 replaced by `setJMenuBar(JMenuBar m)`.
Sets the `menuBar` property for this `JInternalFrame`.

Parameters:
  `m` - the `JMenuBar` to use in this internal frame
See Also:
  - `getJMenuBar()`

### setJMenuBar

@BeanProperty(preferred=true, description="The menu bar for accessing pulldown menus from this internal frame.") public void setJMenuBar(JMenuBar m)
Sets the `menuBar` property for this `JInternalFrame`.

Parameters:
  `m` - the `JMenuBar` to use in this internal frame
See Also:
  - `getJMenuBar()`

### getContentPane

public Container getContentPane()
Returns the content pane for this internal frame.

Specified by:
  `getContentPane` in interface `RootPaneContainer`
Returns:
  the content pane
See Also:
  - `RootPaneContainer.setContentPane(Container)`

### setContentPane

@BeanProperty(hidden=true, description="The client area of the internal frame where child components are normally inserted.") public void setContentPane(Container c)
Sets this `JInternalFrame`'s `contentPane` property.

Specified by:
  `setContentPane` in interface `RootPaneContainer`
Parameters:
  `c` - the content pane for this internal frame
Throws:
  `IllegalComponentStateException` - (a runtime exception) if the content pane parameter is `null`
See Also:
  - `RootPaneContainer.getContentPane()`

### getLayeredPane

public JLayeredPane getLayeredPane()
Returns the layered pane for this internal frame.

Specified by:
  `getLayeredPane` in interface `RootPaneContainer`
Returns:
  a `JLayeredPane` object
See Also:
  - `RootPaneContainer.setLayeredPane(JLayeredPane)`
  - `RootPaneContainer.getLayeredPane()`

### setLayeredPane

@BeanProperty(hidden=true, description="The pane which holds the various desktop layers.") public void setLayeredPane(JLayeredPane layered)
Sets this `JInternalFrame`'s `layeredPane` property.

Specified by:
  `setLayeredPane` in interface `RootPaneContainer`
Parameters:
  `layered` - the `JLayeredPane` for this internal frame
Throws:
  `IllegalComponentStateException` - (a runtime exception) if the layered pane parameter is `null`
See Also:
  - `RootPaneContainer.setLayeredPane(JLayeredPane)`

### getGlassPane

public Component getGlassPane()
Returns the glass pane for this internal frame.

Specified by:
  `getGlassPane` in interface `RootPaneContainer`
Returns:
  the glass pane
See Also:
  - `RootPaneContainer.setGlassPane(Component)`

### setGlassPane

@BeanProperty(hidden=true, description="A transparent pane used for menu rendering.") public void setGlassPane(Component glass)
Sets this `JInternalFrame`'s `glassPane` property.

Specified by:
  `setGlassPane` in interface `RootPaneContainer`
Parameters:
  `glass` - the glass pane for this internal frame
See Also:
  - `RootPaneContainer.getGlassPane()`

### getRootPane

@BeanProperty(hidden=true, description="The root pane used by this internal frame.") public JRootPane getRootPane()
Returns the `rootPane` object for this internal frame.

Specified by:
  `getRootPane` in interface `RootPaneContainer`
Overrides:
  `getRootPane` in class `JComponent`
Returns:
  the `rootPane` property
See Also:
  - `RootPaneContainer.getRootPane()`

### setRootPane

protected void setRootPane(JRootPane root)
Sets the `rootPane` property for this `JInternalFrame`. This method is called by the constructor.

Parameters:
  `root` - the new `JRootPane` object

### setClosable

@BeanProperty(preferred=true, description="Indicates whether this internal frame can be closed.") public void setClosable(boolean b)
Sets whether this `JInternalFrame` can be closed by some user action.

Parameters:
  `b` - a boolean value, where `true` means this internal frame can be closed

### isClosable

public boolean isClosable()
Returns whether this `JInternalFrame` can be closed by some user action.

Returns:
  `true` if this internal frame can be closed

### isClosed

public boolean isClosed()
Returns whether this `JInternalFrame` is currently closed.

Returns:
  `true` if this internal frame is closed, `false` otherwise

### setClosed

@BeanProperty(description="Indicates whether this internal frame has been closed.") public void setClosed(boolean b) throws PropertyVetoException
Closes this internal frame if the argument is `true`. Do not invoke this method with a `false` argument; the result of invoking `setClosed(false)` is unspecified.

If the internal frame is already closed, this method does nothing and returns immediately. Otherwise, this method begins by firing an `INTERNAL_FRAME_CLOSING` event. Then this method sets the `closed` property to `true` unless a listener vetoes the property change. This method finishes by making the internal frame invisible and unselected, and then firing an `INTERNAL_FRAME_CLOSED` event.

Note: To reuse an internal frame that has been closed, you must add it to a container (even if you never removed it from its previous container). Typically, this container will be the `JDesktopPane` that previously contained the internal frame.

Parameters:
  `b` - must be `true`
Throws:
  `PropertyVetoException` - when the attempt to set the property is vetoed by the `JInternalFrame`
See Also:
  - `isClosed()`
  - `setDefaultCloseOperation(int)`
  - `dispose()`
  - `InternalFrameEvent.INTERNAL_FRAME_CLOSING`

### setResizable

@BeanProperty(preferred=true, description="Determines whether this internal frame can be resized by the user.") public void setResizable(boolean b)
Sets whether the `JInternalFrame` can be resized by some user action.

Parameters:
  `b` - a boolean, where `true` means this internal frame can be resized

### isResizable

public boolean isResizable()
Returns whether the `JInternalFrame` can be resized by some user action.

Returns:
  `true` if this internal frame can be resized, `false` otherwise

### setIconifiable

@BeanProperty(preferred=true, description="Determines whether this internal frame can be iconified.") public void setIconifiable(boolean b)
Sets the `iconable` property, which must be `true` for the user to be able to make the `JInternalFrame` an icon. Some look and feels might not implement iconification; they will ignore this property.

Parameters:
  `b` - a boolean, where `true` means this internal frame can be iconified

### isIconifiable

public boolean isIconifiable()
Gets the `iconable` property, which by default is `false`.

Returns:
  the value of the `iconable` property.
See Also:
  - `setIconifiable(boolean)`

### isIcon

public boolean isIcon()
Returns whether the `JInternalFrame` is currently iconified.

Returns:
  `true` if this internal frame is iconified

### setIcon

@BeanProperty(description="The image displayed when this internal frame is minimized.") public void setIcon(boolean b) throws PropertyVetoException
Iconifies or de-iconifies this internal frame, if the look and feel supports iconification. If the internal frame's state changes to iconified, this method fires an `INTERNAL_FRAME_ICONIFIED` event. If the state changes to de-iconified, an `INTERNAL_FRAME_DEICONIFIED` event is fired.

Parameters:
  `b` - a boolean, where `true` means to iconify this internal frame and `false` means to de-iconify it
Throws:
  `PropertyVetoException` - when the attempt to set the property is vetoed by the `JInternalFrame`
See Also:
  - `InternalFrameEvent.INTERNAL_FRAME_ICONIFIED`
  - `InternalFrameEvent.INTERNAL_FRAME_DEICONIFIED`

### setMaximizable

@BeanProperty(preferred=true, description="Determines whether this internal frame can be maximized.") public void setMaximizable(boolean b)
Sets the `maximizable` property, which determines whether the `JInternalFrame` can be maximized by some user action. Some look and feels might not support maximizing internal frames; they will ignore this property.

Parameters:
  `b` - `true` to specify that this internal frame should be maximizable; `false` to specify that it should not be

### isMaximizable

public boolean isMaximizable()
Gets the value of the `maximizable` property.

Returns:
  the value of the `maximizable` property
See Also:
  - `setMaximizable(boolean)`

### isMaximum

public boolean isMaximum()
Returns whether the `JInternalFrame` is currently maximized.

Returns:
  `true` if this internal frame is maximized, `false` otherwise

### setMaximum

@BeanProperty(description="Indicates whether this internal frame is maximized.") public void setMaximum(boolean b) throws PropertyVetoException
Maximizes and restores this internal frame. A maximized frame is resized to fully fit the `JDesktopPane` area associated with the `JInternalFrame`. A restored frame's size is set to the `JInternalFrame`'s actual size.

Parameters:
  `b` - a boolean, where `true` maximizes this internal frame and `false` restores it
Throws:
  `PropertyVetoException` - when the attempt to set the property is vetoed by the `JInternalFrame`

### getTitle

public String getTitle()
Returns the title of the `JInternalFrame`.

Returns:
  a `String` containing this internal frame's title
See Also:
  - `setTitle(String)`

### setTitle

@BeanProperty(preferred=true, description="The text displayed in the title bar.") public void setTitle(String title)
Sets the `JInternalFrame` title. `title` may have a `null` value.

Parameters:
  `title` - the `String` to display in the title bar
See Also:
  - `getTitle()`

### setSelected

@BeanProperty(description="Indicates whether this internal frame is currently the active frame.") public void setSelected(boolean selected) throws PropertyVetoException
Selects or deselects the internal frame if it's showing. A `JInternalFrame` normally draws its title bar differently if it is the selected frame, which indicates to the user that this internal frame has the focus. When this method changes the state of the internal frame from deselected to selected, it fires an `InternalFrameEvent.INTERNAL_FRAME_ACTIVATED` event. If the change is from selected to deselected, an `InternalFrameEvent.INTERNAL_FRAME_DEACTIVATED` event is fired.

Parameters:
  `selected` - a boolean, where `true` means this internal frame should become selected (currently active) and `false` means it should become deselected
Throws:
  `PropertyVetoException` - when the attempt to set the property is vetoed by the `JInternalFrame`
See Also:
  - `Component.isShowing()`
  - `InternalFrameEvent.INTERNAL_FRAME_ACTIVATED`
  - `InternalFrameEvent.INTERNAL_FRAME_DEACTIVATED`

### isSelected

public boolean isSelected()
Returns whether the `JInternalFrame` is the currently "selected" or active frame.

Returns:
  `true` if this internal frame is currently selected (active)
See Also:
  - `setSelected(boolean)`

### setFrameIcon

@BeanProperty(description="The icon shown in the top-left corner of this internal frame.") public void setFrameIcon(Icon icon)
Sets an image to be displayed in the titlebar of this internal frame (usually in the top-left corner). Some look and feels might not support displaying an icon in the titlebar. This image is not the `desktopIcon` object, which is the image displayed in the `JDesktop` when this internal frame is iconified. Passing `null` to this function is valid, but the look and feel can choose the appropriate behavior for that situation, such as displaying no icon or a default icon for the look and feel.

Parameters:
  `icon` - the `Icon` to display in the title bar
See Also:
  - `getFrameIcon()`

### getFrameIcon

public Icon getFrameIcon()
Returns the image displayed in the title bar of this internal frame (usually in the top-left corner).

Returns:
  the `Icon` displayed in the title bar
See Also:
  - `setFrameIcon(Icon)`

### moveToFront

public void moveToFront()
Convenience method that moves this component to position 0 if its parent is a `JLayeredPane`.

### moveToBack

public void moveToBack()
Convenience method that moves this component to position -1 if its parent is a `JLayeredPane`.

### getLastCursor

@BeanProperty(bound=false) public Cursor getLastCursor()
Returns the last `Cursor` that was set by the `setCursor` method that is not a resizable `Cursor`.

Returns:
  the last non-resizable `Cursor`
Since:
  1.6

### setCursor

public void setCursor(Cursor cursor)
Sets the cursor image to the specified cursor. This cursor image is displayed when the `contains` method for this component returns true for the current cursor location, and this Component is visible, displayable, and enabled. Setting the cursor of a `Container` causes that cursor to be displayed within all of the container's subcomponents, except for those that have a non-`null` cursor.

The method may have no visual effect if the Java platform implementation and/or the native system do not support changing the mouse cursor shape.

Overrides:
  `setCursor` in class `Component`
Parameters:
  `cursor` - One of the constants defined by the `Cursor` class; if this parameter is `null` then this component will inherit the cursor of its parent
Since:
  1.6
See Also:
  - `Component.isEnabled()`
  - `Component.isShowing()`
  - `Component.getCursor()`
  - `Component.contains(int, int)`
  - `Toolkit.createCustomCursor(Image, Point, String)`
  - `Cursor`

### setLayer

@BeanProperty(bound=false, expert=true, description="Specifies what desktop layer is used.") public void setLayer(Integer layer)
Convenience method for setting the layer attribute of this component.

Parameters:
  `layer` - an `Integer` object specifying this frame's desktop layer
Throws:
  `NullPointerException` - if `layer` is `null`
See Also:
  - `JLayeredPane`

### setLayer

@BeanProperty(bound=false, expert=true, description="Specifies what desktop layer is used.") public void setLayer(int layer)
Convenience method for setting the layer attribute of this component. The method `setLayer(Integer)` should be used for layer values predefined in `JLayeredPane`. When using `setLayer(int)`, care must be taken not to accidentally clash with those values.

Parameters:
  `layer` - an integer specifying this internal frame's desktop layer
Since:
  1.3
See Also:
  - `setLayer(Integer)`
  - `JLayeredPane`

### getLayer

public int getLayer()
Convenience method for getting the layer attribute of this component.

Returns:
  an `Integer` object specifying this frame's desktop layer
See Also:
  - `JLayeredPane`

### getDesktopPane

@BeanProperty(bound=false) public JDesktopPane getDesktopPane()
Convenience method that searches the ancestor hierarchy for a `JDesktop` instance. If `JInternalFrame` finds none, the `desktopIcon` tree is searched.

Returns:
  the `JDesktopPane` this internal frame belongs to, or `null` if none is found

### setDesktopIcon

@BeanProperty(description="The icon shown when this internal frame is minimized.") public void setDesktopIcon(JInternalFrame.JDesktopIcon d)
Sets the `JDesktopIcon` associated with this `JInternalFrame`.

Parameters:
  `d` - the `JDesktopIcon` to display on the desktop
Throws:
  `NullPointerException` - if the `d` is `null`
See Also:
  - `getDesktopIcon()`

### getDesktopIcon

public JInternalFrame.JDesktopIcon getDesktopIcon()
Returns the `JDesktopIcon` used when this `JInternalFrame` is iconified.

Returns:
  the `JDesktopIcon` displayed on the desktop
See Also:
  - `setDesktopIcon(JInternalFrame.JDesktopIcon)`

### getNormalBounds

public Rectangle getNormalBounds()
If the `JInternalFrame` is not in maximized state, returns `getBounds()`; otherwise, returns the bounds that the `JInternalFrame` would be restored to.

Returns:
  a `Rectangle` containing the bounds of this frame when in the normal state
Since:
  1.3

### setNormalBounds

public void setNormalBounds(Rectangle r)
Sets the normal bounds for this internal frame, the bounds that this internal frame would be restored to from its maximized state. This method is intended for use only by desktop managers.

Parameters:
  `r` - the bounds that this internal frame should be restored to
Since:
  1.3

### getFocusOwner

public Component getFocusOwner()
If this `JInternalFrame` is active, returns the child that has focus. Otherwise, returns `null`.

Returns:
  the component with focus, or `null` if no children have focus
Since:
  1.3

### getMostRecentFocusOwner

@BeanProperty(bound=false) public Component getMostRecentFocusOwner()
Returns the child component of this `JInternalFrame` that will receive the focus when this `JInternalFrame` is selected. If this `JInternalFrame` is currently selected, this method returns the same component as the `getFocusOwner` method. If this `JInternalFrame` is not selected, then the child component that most recently requested focus will be returned. If no child component has ever requested focus, then this `JInternalFrame`'s initial focusable component is returned. If no such child exists, then this `JInternalFrame`'s default component to focus is returned.

Returns:
  the child component that will receive focus when this `JInternalFrame` is selected
Since:
  1.4
See Also:
  - `getFocusOwner()`
  - `isSelected`

### restoreSubcomponentFocus

public void restoreSubcomponentFocus()
Requests the internal frame to restore focus to the last subcomponent that had focus. This is used by the UI when the user selected this internal frame -- for example, by clicking on the title bar.

Since:
  1.3

### reshape

public void reshape(int x, int y, int width, int height)
Moves and resizes this component. Unlike other components, this implementation also forces re-layout, so that frame decorations such as the title bar are always redisplayed.

Overrides:
  `reshape` in class `JComponent`
Parameters:
  `x` - an integer giving the component's new horizontal position measured in pixels from the left of its container
  `y` - an integer giving the component's new vertical position, measured in pixels from the bottom of its container
  `width` - an integer giving the component's new width in pixels
  `height` - an integer giving the component's new height in pixels
See Also:
  - `Component.setBounds(int, int, int, int)`

### addInternalFrameListener

public void addInternalFrameListener(InternalFrameListener l)
Adds the specified listener to receive internal frame events from this internal frame.

Parameters:
  `l` - the internal frame listener

### removeInternalFrameListener

public void removeInternalFrameListener(InternalFrameListener l)
Removes the specified internal frame listener so that it no longer receives internal frame events from this internal frame.

Parameters:
  `l` - the internal frame listener

### getInternalFrameListeners

@BeanProperty(bound=false) public InternalFrameListener[] getInternalFrameListeners()
Returns an array of all the `InternalFrameListener`s added to this `JInternalFrame` with `addInternalFrameListener`.

Returns:
  all of the `InternalFrameListener`s added or an empty array if no listeners have been added
Since:
  1.4
See Also:
  - `addInternalFrameListener(InternalFrameListener)`

### fireInternalFrameEvent

protected void fireInternalFrameEvent(int id)
Fires an internal frame event.

Parameters:
  `id` - the type of the event being fired; one of the following:
  - `InternalFrameEvent.INTERNAL_FRAME_OPENED`
  - `InternalFrameEvent.INTERNAL_FRAME_CLOSING`
  - `InternalFrameEvent.INTERNAL_FRAME_CLOSED`
  - `InternalFrameEvent.INTERNAL_FRAME_ICONIFIED`
  - `InternalFrameEvent.INTERNAL_FRAME_DEICONIFIED`
  - `InternalFrameEvent.INTERNAL_FRAME_ACTIVATED`
  - `InternalFrameEvent.INTERNAL_FRAME_DEACTIVATED`
  If the event type is not one of the above, nothing happens.

### doDefaultCloseAction

public void doDefaultCloseAction()
Fires an `INTERNAL_FRAME_CLOSING` event and then performs the action specified by the internal frame's default close operation. This method is typically invoked by the look-and-feel-implemented action handler for the internal frame's close button.

Since:
  1.3
See Also:
  - `setDefaultCloseOperation(int)`
  - `InternalFrameEvent.INTERNAL_FRAME_CLOSING`

### setDefaultCloseOperation

public void setDefaultCloseOperation(int operation)
Sets the operation that will happen by default when the user initiates a "close" on this internal frame. The possible choices are:

`DO_NOTHING_ON_CLOSE`
  Do nothing. This requires the program to handle the operation in the `internalFrameClosing` method of a registered `InternalFrameListener` object.
`HIDE_ON_CLOSE`
  Automatically make the internal frame invisible.
`DISPOSE_ON_CLOSE`
  Automatically dispose of the internal frame.

The default value is `DISPOSE_ON_CLOSE`. Before performing the specified close operation, the internal frame fires an `INTERNAL_FRAME_CLOSING` event.

Parameters:
  `operation` - one of the following constants defined in `javax.swing.WindowConstants` (an interface implemented by `JInternalFrame`): `DO_NOTHING_ON_CLOSE`, `HIDE_ON_CLOSE`, or `DISPOSE_ON_CLOSE`
See Also:
  - `addInternalFrameListener(InternalFrameListener)`
  - `getDefaultCloseOperation()`
  - `JComponent.setVisible(boolean)`
  - `dispose()`
  - `InternalFrameEvent.INTERNAL_FRAME_CLOSING`

### getDefaultCloseOperation

public int getDefaultCloseOperation()
Returns the default operation that occurs when the user initiates a "close" on this internal frame.

Returns:
  the operation that will occur when the user closes the internal frame
See Also:
  - `setDefaultCloseOperation(int)`

### pack

public void pack()
Causes subcomponents of this `JInternalFrame` to be laid out at their preferred size. Internal frames that are iconized or maximized are first restored and then packed. If the internal frame is unable to be restored its state is not changed and will not be packed.

See Also:
  - `Window.pack()`

### show

public void show()
If the internal frame is not visible, brings the internal frame to the front, makes it visible, and attempts to select it. The first time the internal frame is made visible, this method also fires an `INTERNAL_FRAME_OPENED` event. This method does nothing if the internal frame is already visible. Invoking this method has the same result as invoking `setVisible(true)`.

Overrides:
  `show` in class `Component`
See Also:
  - `moveToFront()`
  - `setSelected(boolean)`
  - `InternalFrameEvent.INTERNAL_FRAME_OPENED`
  - `JComponent.setVisible(boolean)`

### hide

public void hide()
Description copied from class: `JComponent`

Overrides:
  `hide` in class `JComponent`

### dispose

public void dispose()
Makes this internal frame invisible, unselected, and closed. If the frame is not already closed, this method fires an `INTERNAL_FRAME_CLOSED` event. The results of invoking this method are similar to `setClosed(true)`, but `dispose` always succeeds in closing the internal frame and does not fire an `INTERNAL_FRAME_CLOSING` event.

See Also:
  - `InternalFrameEvent.INTERNAL_FRAME_CLOSED`
  - `JComponent.setVisible(boolean)`
  - `setSelected(boolean)`
  - `setClosed(boolean)`

### toFront

public void toFront()
Brings this internal frame to the front. Places this internal frame at the top of the stacking order and makes the corresponding adjustment to other visible internal frames.

See Also:
  - `Window.toFront()`
  - `moveToFront()`

### toBack

public void toBack()
Sends this internal frame to the back. Places this internal frame at the bottom of the stacking order and makes the corresponding adjustment to other visible internal frames.

See Also:
  - `Window.toBack()`
  - `moveToBack()`

### setFocusCycleRoot

public final void setFocusCycleRoot(boolean focusCycleRoot)
Does nothing because `JInternalFrame`s must always be roots of a focus traversal cycle.

Overrides:
  `setFocusCycleRoot` in class `Container`
Parameters:
  `focusCycleRoot` - this value is ignored
Since:
  1.4
See Also:
  - `isFocusCycleRoot()`
  - `Container.setFocusTraversalPolicy(FocusTraversalPolicy)`
  - `Container.getFocusTraversalPolicy()`

### isFocusCycleRoot

public final boolean isFocusCycleRoot()
Always returns `true` because all `JInternalFrame`s must be roots of a focus traversal cycle.

Overrides:
  `isFocusCycleRoot` in class `Container`
Returns:
  `true`
Since:
  1.4
See Also:
  - `setFocusCycleRoot(boolean)`
  - `Container.setFocusTraversalPolicy(FocusTraversalPolicy)`
  - `Container.getFocusTraversalPolicy()`

### getFocusCycleRootAncestor

@BeanProperty(bound=false) public final Container getFocusCycleRootAncestor()
Always returns `null` because `JInternalFrame`s must always be roots of a focus traversal cycle.

Overrides:
  `getFocusCycleRootAncestor` in class `Component`
Returns:
  `null`
Since:
  1.4
See Also:
  - `Container.isFocusCycleRoot()`

### getWarningString

@Deprecated(since="24", forRemoval=true) @BeanProperty(bound=false) public final String getWarningString()
Deprecated, for removal: This API element is subject to removal in a future version.
since JDK 24
Gets the warning string that is displayed with this internal frame. This method always returns `null`. Warning strings are no longer applicable, even to top-level windows, so this method may be removed in a future release

Returns:
  `null`
See Also:
  - `Window.getWarningString()`

### paramString

protected String paramString()
Returns a string representation of this `JInternalFrame`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

Overrides:
  `paramString` in class `JComponent`
Returns:
  a string representation of this `JInternalFrame`

### paintComponent

protected void paintComponent(Graphics g)
Overridden to allow optimized painting when the internal frame is being dragged.

Overrides:
  `paintComponent` in class `JComponent`
Parameters:
  `g` - the `Graphics` object to protect
See Also:
  - `JComponent.paint(Graphics)`
  - `ComponentUI`

### getAccessibleContext

@BeanProperty(bound=false) public AccessibleContext getAccessibleContext()
Gets the `AccessibleContext` associated with this `JInternalFrame`. For internal frames, the `AccessibleContext` takes the form of an `AccessibleJInternalFrame` object. A new `AccessibleJInternalFrame` instance is created if necessary.

Specified by:
  `getAccessibleContext` in interface `Accessible`
Overrides:
  `getAccessibleContext` in class `Component`
Returns:
  an `AccessibleJInternalFrame` that serves as the `AccessibleContext` of this `JInternalFrame`
See Also:
  - `JInternalFrame.AccessibleJInternalFrame`